Material Object

Functions
Material Object
Evas » Evas 3D Extensions

A material object represents properties of surfaces. More...

## Functions
EOAPI void | evas_canvas3d_material_enable_set (Evas_Canvas3D_Material_Attrib attrib, Eina_Bool enable)
| Set the material attribute enable flag of the given material. More...
EOAPI Eina_Bool | evas_canvas3d_material_enable_get (Evas_Canvas3D_Material_Attrib attrib)
| Get the material attribute enable flag of the given material. More...
EOAPI void | evas_canvas3d_material_shininess_set (Evas_Real shininess)
| Set the shininess of the given material. More...
EOAPI Evas_Real | evas_canvas3d_material_shininess_get (void)
| Get the shininess of the given material. More...
EOAPI void | evas_canvas3d_material_texture_set (Evas_Canvas3D_Material_Attrib attrib, Evas_Canvas3D_Texture *texture)
| Set the texture of the given material. More...
EOAPI Evas_Canvas3D_Texture * | evas_canvas3d_material_texture_get (Evas_Canvas3D_Material_Attrib attrib)
| Get the texture of the given material. More...
EOAPI void | evas_canvas3d_material_color_set (Evas_Canvas3D_Material_Attrib attrib, Evas_Real r, Evas_Real g, Evas_Real b, Evas_Real a)
| Set the material attribute color of the given material. More...
EOAPI void | evas_canvas3d_material_color_get (Evas_Canvas3D_Material_Attrib attrib, Evas_Real *r, Evas_Real *g, Evas_Real *b, Evas_Real *a)
| Get the material attribute color of the given material. More...

## Detailed Description

A material object represents properties of surfaces.

Evas 3D defines the properties with 5 material attributes, ambient, diffuse, specular emission and normal. Each attribute have its color value and texture map. Materials are used to determine the color of mesh surfaces.

## Function Documentation

## ◆ evas_canvas3d_material_enable_set()

EOAPI void evas_canvas3d_material_enable_set | ( | Evas_Canvas3D_Material_Attrib | attrib,
|  | Eina_Bool | enable
| ) |  |

Set the material attribute enable flag of the given material.

You might want to disable some material reflection contribution. For example, Emission attribute is rarely used. Disabling unused attributes might help the shading less complex so that can get speed up.

By default, diffuse and specular is enabled.

Parameters

  [in] | attrib | Material attribute ID.
  [in] | enable | Whether to enable the attribute or not.

## ◆ evas_canvas3d_material_enable_get()

EOAPI Eina_Bool evas_canvas3d_material_enable_get | ( | Evas_Canvas3D_Material_Attrib | attrib | ) |

Get the material attribute enable flag of the given material.

See also evas_canvas3d_material_enable_set.

Parameters

  [in] | attrib | Material attribute ID.

Returns
  Whether to enable the attribute or not.

## ◆ evas_canvas3d_material_shininess_set()

EOAPI void evas_canvas3d_material_shininess_set | ( | Evas_Real | shininess | ) |

Set the shininess of the given material.

Shininess is only used when specular attribute is enabled. Higher shininess value will make the object more shiny.

Default shininess value is 150.0.

See also evas_canvas3d_material_enable_set.

Parameters

  [in] | shininess | Shininess value.

## ◆ evas_canvas3d_material_shininess_get()

EOAPI Evas_Real evas_canvas3d_material_shininess_get | ( | void |  | ) |

Get the shininess of the given material.

See also evas_canvas3d_material_shininess_set.

Returns
  Shininess value.

## ◆ evas_canvas3d_material_texture_set()

EOAPI void evas_canvas3d_material_texture_set | ( | Evas_Canvas3D_Material_Attrib | attrib,
|  | Evas_Canvas3D_Texture * | texture
| ) |  |

Set the texture of the given material.

You have to enable the desired attribute first.

See also evas_canvas3d_material_enable_set.

Parameters

  [in] | attrib | Material attribute ID.
  [in] | texture | The texture set to the attribute.

## ◆ evas_canvas3d_material_texture_get()

EOAPI Evas_Canvas3D_Texture* evas_canvas3d_material_texture_get | ( | Evas_Canvas3D_Material_Attrib | attrib | ) |

Get the texture of the given material.

See also evas_canvas3d_material_texture_set.

Parameters

  [in] | attrib | Material attribute ID.

Returns
  The texture set to the attribute.

## ◆ evas_canvas3d_material_color_set()

EOAPI void evas_canvas3d_material_color_set | ( | Evas_Canvas3D_Material_Attrib | attrib,
|  | Evas_Real | r,
|  | Evas_Real | g,
|  | Evas_Real | b,
|  | Evas_Real | a
| ) |  |

Set the material attribute color of the given material.

Material color is used also when texture map is enabled. The colors will be modulated (multiplied). To control the color contribution of a material attribute, use gray color. Setting color value for normal attribute has no effect.

Default color is as follows.

Ambient : (0.2, 0.2, 0.2, 1.0) Diffuse : (0.8, 0.8, 0.8, 1.0) Specular : (1.0, 1.0, 1.0, 1.0) Emission : (0.0, 0.0, 0.0, 1.0) Normal : Not used

Parameters

  [in] | r | Red component of the color.
  [in] | g | Green component of the color.
  [in] | b | Blue component of the color.
  [in] | a | Alpha component of the color.

## ◆ evas_canvas3d_material_color_get()

EOAPI void evas_canvas3d_material_color_get | ( | Evas_Canvas3D_Material_Attrib | attrib,
|  | Evas_Real * | r,
|  | Evas_Real * | g,
|  | Evas_Real * | b,
|  | Evas_Real * | a
| ) |  |

Get the material attribute color of the given material.

See also evas_canvas3d_material_color_set.

Parameters

  [out] | r | Pointer to receive red component of the color.
  [out] | g | Pointer to receive green component of the color.
  [out] | b | Pointer to receive blue component of the color.
  [out] | a | Pointer to receive alpha component of the color.